Subject: bug#14849: closed (Re: bug#14849: (system vm coverage) `line-execution-counts' misleading output)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 21 Jun 2016 07:10:02 +0000

Your bug report

#14849: (system vm coverage) `line-execution-counts' misleading output

which was filed against the guile package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
14849: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=14849
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#14849: (system vm coverage) `line-execution-counts' misleading output
From: Andy Wingo <[email-masked]>
To: [email-masked] (Taylan Ulrich B.)
Cc: [email-masked]
Date: Tue, 21 Jun 2016 09:09:02 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

I have tried this one on master and it exhibits the results you expect,
not the buggy results.  I added the test to the test suite.  I don't
plan on devoting resource to fixing this bug in 2.0 though, so I'm
closing it for now.  Feel free to reopen if you hvae a patch to fix :)

Andy

On Fri 12 Jul 2013 16:47, [email-masked] (Taylan Ulrich B.) writes:

> The following shell/guile transcript showcases a minimal test-case for
> when a tail-call fools the code-coverage module into thinking that the
> line with the tail-call was not executed.
>
> The result in the Guile transcript, $1, is an alist from line numbers
> (starting from zero) to execution counts.
>
> Converting the relevant coverage-data object into LCOV data via
> `coverage-data->lcov', as advertised in (info "(guile) Code
> Coverage"), then to HTML via LCOV's genhtml(1), will result in the
> relevant line being colored red and contribute negatively to the total
> line-coverage percentage.
>
> === BEGIN TRANSCRIPT ===
> $ cat /tmp/test.scm  
> (define (tail-call-test)
>   (display "foo\n")
>   (tail-call-target))
>
> (define (tail-call-target)
>   (display "bar\n"))
> $ guile              
> GNU Guile 2.0.9.20-10454
> Copyright (C) 1995-2013 Free Software Foundation, Inc.
>
> Guile comes with ABSOLUTELY NO WARRANTY; for details type `,show w'.
> This program is free software, and you are welcome to redistribute it
> under certain conditions; type `,show c' for details.
>
> Enter `,help' for help.
> scheme@(guile-user)> (begin
> ...   (load "/tmp/test.scm")
> ...   (call-with-values
> ...       (lambda ()
> ...         ((@ (system vm coverage) with-code-coverage)
> ...          ((@ (system vm vm) the-vm))
> ...          tail-call-test))
> ...     (lambda (data . values)
> ...       ((@ (system vm coverage) line-execution-counts) data "/tmp/test.scm"))))
> ;;; <stdin>:0:4095: warning: possibly unbound variable `tail-call-test'
> foo
> bar
> $1 = ((5 . 1) (4 . 1) (2 . 0) (1 . 1) (0 . 1))
> scheme@(guile-user)> 
> === END TRANSCRIPT ===

Subject: (system vm coverage) `line-execution-counts' misleading output
From: [email-masked] (Taylan Ulrich B.)
To: [email-masked]
Date: Fri, 12 Jul 2013 16:47:00 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

The following shell/guile transcript showcases a minimal test-case for
when a tail-call fools the code-coverage module into thinking that the
line with the tail-call was not executed.

The result in the Guile transcript, $1, is an alist from line numbers
(starting from zero) to execution counts.

Converting the relevant coverage-data object into LCOV data via
`coverage-data->lcov', as advertised in (info "(guile) Code
Coverage"), then to HTML via LCOV's genhtml(1), will result in the
relevant line being colored red and contribute negatively to the total
line-coverage percentage.

=== BEGIN TRANSCRIPT ===
$ cat /tmp/test.scm  
(define (tail-call-test)
  (display "foo\n")
  (tail-call-target))

(define (tail-call-target)
  (display "bar\n"))
$ guile              
GNU Guile 2.0.9.20-10454
Copyright (C) 1995-2013 Free Software Foundation, Inc.

Guile comes with ABSOLUTELY NO WARRANTY; for details type `,show w'.
This program is free software, and you are welcome to redistribute it
under certain conditions; type `,show c' for details.

Enter `,help' for help.
scheme@(guile-user)> (begin
...   (load "/tmp/test.scm")
...   (call-with-values
...       (lambda ()
...         ((@ (system vm coverage) with-code-coverage)
...          ((@ (system vm vm) the-vm))
...          tail-call-test))
...     (lambda (data . values)
...       ((@ (system vm coverage) line-execution-counts) data "/tmp/test.scm"))))
;;; <stdin>:0:4095: warning: possibly unbound variable `tail-call-test'
foo
bar
$1 = ((5 . 1) (4 . 1) (2 . 0) (1 . 1) (0 . 1))
scheme@(guile-user)> 
=== END TRANSCRIPT ===